org.apache.hc.core5.http.io.entity

## Class SerializableEntity

- java.lang.Object
- - org.apache.hc.core5.http.io.entity.AbstractHttpEntity
  - - org.apache.hc.core5.http.io.entity.SerializableEntity

- All Implemented Interfaces:
    Closeable, AutoCloseable, EntityDetails, HttpEntity

      @Contract(threading=IMMUTABLE_CONDITIONAL)
      public class SerializableEntity
      extends AbstractHttpEntity

  A streamed entity that obtains its content from a `Serializable`.

  This class contains `immutable attributes` but subclasses may contain additional immutable or mutable attributes.

  Since:
    4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SerializableEntity(Serializable serializable, ContentType contentType)` Creates new instance of this class.
    `SerializableEntity(Serializable serializable, ContentType contentType, String contentEncoding)` Creates new instance of this class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `InputStream` | `getContent()` Gets a content stream of the entity.
    `long` | `getContentLength()` Gets length of this entity, if known.
    `boolean` | `isRepeatable()` Tests if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tests whether this entity depends on an underlying stream.
    `void` | `writeTo(OutputStream outStream)` Writes this entity to an OutputStream.

    - ### Methods inherited from class org.apache.hc.core5.http.io.entity.AbstractHttpEntity

      `getContentEncoding, getContentType, getTrailerNames, getTrailers, isChunked, toString, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SerializableEntity

          public SerializableEntity(Serializable serializable,
                                    ContentType contentType,
                                    String contentEncoding)

      Creates new instance of this class.

      The new instance:

      - is not chunked.
      Parameters:
        `serializable` - the serializable object.
        `contentType` - the content type.
        `contentEncoding` - the content encoding.

    - #### SerializableEntity

          public SerializableEntity(Serializable serializable,
                                    ContentType contentType)

      Creates new instance of this class.

      The new instance:

      - is not chunked.
      - does not define a content encoding.
      Parameters:
        `serializable` - the serializable object.
        `contentType` - the content type.

  - ### Method Detail

    - #### getContent

          public final InputStream getContent()
                                       throws IOException,
                                              IllegalStateException

      Description copied from interface: `HttpEntity`
      Gets a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Returns:
        content stream of the entity.
      Throws:
        `IOException` - if the stream could not be created
        `IllegalStateException`
      See Also:
        `HttpEntity.isRepeatable()`

    - #### getContentLength

          public final long getContentLength()

      Gets length of this entity, if known.

      This implementation always returns `-1`.

      Returns:
        the length of this entity, may be `0`.

    - #### isRepeatable

          public final boolean isRepeatable()

      Tests if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.

      This implementation always returns `false`.

      This implementation always returns `true`.

      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Overrides:
        `isRepeatable` in class `AbstractHttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### isStreaming

          public final boolean isStreaming()

      Tests whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.

      This implementation always returns `false`.

      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### writeTo

          public final void writeTo(OutputStream outStream)
                             throws IOException

      Description copied from class: `AbstractHttpEntity`
      Writes this entity to an OutputStream.
      Specified by:
        `writeTo` in interface `HttpEntity`
      Overrides:
        `writeTo` in class `AbstractHttpEntity`
      Parameters:
        `outStream` - Where to write the entity, never null.
      Throws:
        `IOException` - if the entity cannot generate its content stream; also thrown if the output stream is closed.

    - #### close

          public final void close()
                           throws IOException

      This implementation is a no-op.

      Throws:
        `IOException`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.